﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Management; // need to add System.Management to your project references.

namespace FFTapp
{
    class CDCcom
    {
        private string DeviceID;
        private string DeviceName = null;
        private string Port;
        private string MyVidPid;


        public CDCcom(string MyVidPid)
        {
            this.MyVidPid = MyVidPid;
        }

        public string getComNumber()
        {

            ManagementObjectCollection collection;
            using (var searcher = new ManagementObjectSearcher(@"Select * From Win32_PnPEntity"))
                collection = searcher.Get();

            foreach (var device in collection)
            {
                DeviceID = (string)device.GetPropertyValue("DeviceID");

                if (DeviceID.IndexOf(@"USB\" + MyVidPid) == 0)
                {
                    DeviceName = (string)device.GetPropertyValue("Name");

                    int i = DeviceName.IndexOf("COM");
                    int j = DeviceName.IndexOf(")");
                    Port = DeviceName.Substring(i, j - i);
                    break;
                }
            }

            if (DeviceName == null) { return (null); }
            else return Port;
        }

    }
}
